using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace WindowsApplication11
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(24, 24);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(376, 328);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			this.gridDataBoundGrid1.CurrentCellValidating += new System.ComponentModel.CancelEventHandler(this.gridDataBoundGrid1_CurrentCellValidating);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridDataBoundGrid1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");

			 
			int nRows = 10;

			 
			dt.Columns.Add(new DataColumn("BranchID", typeof(Int32) ));
			dt.Columns.Add(new DataColumn("CategoryID", typeof(Int32) ));
			dt.Columns.Add(new DataColumn("PartID"));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				 dr[0] = i;
				dt.Rows.Add(dr);
			}

			this.gridDataBoundGrid1.DataSource = dt;

			this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(gridModel_QueryCellInfo);
			
			this.gridDataBoundGrid1.Model.SaveCellInfo += new GridSaveCellInfoEventHandler(gridModel_SaveCellInfo);
		}

		private Hashtable stringCells = new Hashtable();

		private void gridModel_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			int key = 10000 * e.ColIndex + e.RowIndex;
			if(this.stringCells.ContainsKey(key))
			{
				e.Style.CellValueType = typeof(String);
				e.Style.Text = this.stringCells[key].ToString();
			}
		}


		//allow text in col 2
		private void gridModel_SaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			if(e.RowIndex > 0 && e.ColIndex == 2)
			{
				double d;
				if(!double.TryParse(e.Style.Text, System.Globalization.NumberStyles.Any, null, out d))
				{
					e.Handled = true;
				}
			}
		}

		 
		private void gridDataBoundGrid1_CurrentCellValidating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
			if(cc.RowIndex > 0 && cc.ColIndex == 2)
			{
				double d;
				int key = 10000 * cc.ColIndex + cc.RowIndex;
				if(!double.TryParse(cc.Renderer.ControlText, System.Globalization.NumberStyles.Any, null, out d))
				{
					
					if(this.stringCells.ContainsKey(key))
					{
						this.stringCells[key] = cc.Renderer.ControlText;
					}
					else
					{
						this.stringCells.Add(key, cc.Renderer.ControlText);
					}

					cc.Renderer.ControlText = "1";
				}
				else
				{
					if(this.stringCells.ContainsKey(key))
						this.stringCells.Remove(key);
				}
			}
		}
	}
}
